Subject: RE: Discussion on E-Tree and H-VPLS

From: Jiangyuanlong <[email-masked]>
Date: Fri, 11 May 2012 02:03:10 +0000

Hi Daniel and all,

When you set up two PWs from the PE-rs to a PE-r for each of its AC, do you mean that one PW is bidirectional root PW and the other is bidirectional leaf PW?
My concern is: where should the leaf traffic be filtered, on the PE-rs or on the PE-r?
If filtered on the PE-r, then lots of bandwidth will be wasted (for example, if the PE-r is attached with 9 leafs, then the BUM traffic from one of its leafs will be multiplied by 8 times, and be forwarded by the PE-rs to the same PE-r).
If filtered on the PE-rs, not sure how you will design its forwarding plane, can you give a hint?

Thanks,
Yuanlong

------------------------------
Date: Wed, 9 May 2012 09:16:36 +0300
From: "Daniel Cohn" <[email-masked]>
To: "Alexander Vainshtein" <[email-masked]>,	"Sam
	Cao" <[email-masked]>, <[email-masked]>
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS
Message-ID: <44F4E579A764584EA9BDFD07D0CA08130780CBA6@tlvmail1>
Content-Type: text/plain;	charset="ISO-2022-JP"

Hi Sasha,

It's actually very simple. A frame that originated in a root AC is always transmitted only in root PW, no matter what the frame type (known/unknown unicast or broadcast). This is how the frame source information is propagated across the VPLS. So in the H-VPLS example, the PE-r will never forward a frame received over a root PW on any leaf PW, only on root PWs (toward the core or toward other spokes).

Hope this clarifies it, regards,

Daniel

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Alexander Vainshtein
Sent: Wednesday, May 09, 2012 7:59 AM
To: Sam Cao; [email-masked]
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam, Lizhong and all,
You've written that in the two-PW solution combined with H-VPLS the PE-r must set up two PWs with each MTU-s.

If this is the case, what kind of forwarding logic should be used to prevent sending a BUM frame received from a root-PW to a given MTU-S:
- back to the same MTU-S on the corresponding leaf-PW?
- twice (to both root-PW and Leaf-PW) to another MTU-s? And, BTW, how is the PW selected in this case?

I am aware of a technique of multiple split horizon groups in PE-r which could be possibly used for this purpose. However, since these groups have to be represented explicitly in the data plane, their potential number is limited by the forwarding HW. Other methods could be probably used for the same purpose, but they would probably subject to similar HW-based limitations.

I suspect that with the dual-PW approach, the HW would pose an implicit limit, say, on a number of MTU-s that can be connected to the same PE-r and that this limit could be quite low in most cases.

Based on this I suspect that the H-VPLS issue as a critical drawback of the dual-PW approach to E-Tree.

My 2c,
     Sasha

________________________________________
From: [email-masked] [[email-masked]] on behalf of Sam Cao [[email-masked]]
Sent: Wednesday, May 09, 2012 3:40 AM
To: [email-masked]
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Lizhong?

Thank you very much for your comments. I updated the result on this question.

[Lizhong] agree with the above analysis. And we did not say it is a technical problem, but it is an operational problem again.
[Sam] I agree. Dual-VLAN does not make sense. I also discussed this with Giles and Yuanlong in another mail, and we reached agreement on this: MTU should know the access mode, VPWS or VPLS, VPWS mode should configure VLAN ID on MTU but VPLS mode can not. I thought this is NOT reasonable :), but we can figure this out in draft. It seems ok.

[Lizhong] not fully understand. Do you mean,  when VPWS accessing for H-VPLS, the PE-r is also necessary to configure two PWs (root and leaf PW) for each AC access?
[Sam] Yes.

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Sun, 13 May 2012 20:11:47 +0800

Hi Yuanlong,

Any bridging capable box will filter the traffic, or say, on the PE-rs.
Multi-PW approach will fully comply with RFC 4762, and please read RFC 4762
and multi-PW draft.

Regards,
 
Yuqun (Sam) Cao
E-mail: [email-masked] 
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 10:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

When you set up two PWs from the PE-rs to a PE-r for each of its AC, do you
mean that one PW is bidirectional root PW and the other is bidirectional
leaf PW?
My concern is: where should the leaf traffic be filtered, on the PE-rs or on
the PE-r?
If filtered on the PE-r, then lots of bandwidth will be wasted (for example,
if the PE-r is attached with 9 leafs, then the BUM traffic from one of its
leafs will be multiplied by 8 times, and be forwarded by the PE-rs to the
same PE-r).
If filtered on the PE-rs, not sure how you will design its forwarding plane,
can you give a hint?

Thanks,
Yuanlong

Hi Sasha,

It's actually very simple. A frame that originated in a root AC is always
transmitted only in root PW, no matter what the frame type (known/unknown
unicast or broadcast). This is how the frame source information is
propagated across the VPLS. So in the H-VPLS example, the PE-r will never
forward a frame received over a root PW on any leaf PW, only on root PWs
(toward the core or toward other spokes).

Daniel

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
Alexander Vainshtein

Sam, Lizhong and all,
You've written that in the two-PW solution combined with H-VPLS the PE-r
must set up two PWs with each MTU-s.

If this is the case, what kind of forwarding logic should be used to prevent
sending a BUM frame received from a root-PW to a given MTU-S:
- back to the same MTU-S on the corresponding leaf-PW?
- twice (to both root-PW and Leaf-PW) to another MTU-s? And, BTW, how is the
PW selected in this case?

I am aware of a technique of multiple split horizon groups in PE-r which
could be possibly used for this purpose. However, since these groups have to
be represented explicitly in the data plane, their potential number is
limited by the forwarding HW. Other methods could be probably used for the
same purpose, but they would probably subject to similar HW-based
limitations.

I suspect that with the dual-PW approach, the HW would pose an implicit
limit, say, on a number of MTU-s that can be connected to the same PE-r and
that this limit could be quite low in most cases.

Based on this I suspect that the H-VPLS issue as a critical drawback of the
dual-PW approach to E-Tree.

My 2c,
     Sasha

From: [email-masked] [[email-masked]] on behalf of Sam Cao
[[email-masked]]

Hi Lizhong?

Thank you very much for your comments. I updated the result on this
question.

[Lizhong] agree with the above analysis. And we did not say it is a
technical problem, but it is an operational problem again.
[Sam] I agree. Dual-VLAN does not make sense. I also discussed this with
Giles and Yuanlong in another mail, and we reached agreement on this: MTU
should know the access mode, VPWS or VPLS, VPWS mode should configure VLAN
ID on MTU but VPLS mode can not. I thought this is NOT reasonable :), but we
can figure this out in draft. It seems ok.

[Lizhong] not fully understand. Do you mean,  when VPWS accessing for
H-VPLS, the PE-r is also necessary to configure two PWs (root and leaf PW)
for each AC access?
[Sam] Yes.

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Mon, 14 May 2012 02:37:51 +0000

Sam, from the multi-PW draft, it seems only one PW is set up, but from the emails, two PWs are set up.
Thus I am not sure which approach is in your favor.

RFC 4762 only needs one PW, and split horizon is used to guarrantee that leaf to leaf traffic is filtered, are you suggesting to use the same mechanism in 2PW?

Thanks,
Yuanlong

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Sunday, May 13, 2012 8:12 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 10:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Daniel Cohn" <[email-masked]>
Date: Mon, 14 May 2012 10:36:43 +0300

Hi Yuanlong,

As I see it, for the PE-r spoke (figure 4 in RFC 4762) we establish a
single PW per AC - root PW for root AC and leaf PW for leaf AC. With
local configuration at the PE-rs as part of the spoke PW provisioning.
And the PE-rs will treat root/leaf spoke PWs exactly as it treat
root/leaf ACs. So when leaf-originated BUM traffic arrives from the core
(over a leaf PW), it will be forwarded over all root spoke PWs but not
on the leaf spoke PWs. 
The forwarding plane is exactly the same as described in the multi-PW
draft, where spoke PWs are treated exactly like ACs.

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

When you set up two PWs from the PE-rs to a PE-r for each of its AC, do
you mean that one PW is bidirectional root PW and the other is
bidirectional leaf PW?
My concern is: where should the leaf traffic be filtered, on the PE-rs
or on the PE-r?
If filtered on the PE-r, then lots of bandwidth will be wasted (for
example, if the PE-r is attached with 9 leafs, then the BUM traffic from
one of its leafs will be multiplied by 8 times, and be forwarded by the
PE-rs to the same PE-r).
If filtered on the PE-rs, not sure how you will design its forwarding
plane, can you give a hint?

Thanks,
Yuanlong

Hi Sasha,

It's actually very simple. A frame that originated in a root AC is
always transmitted only in root PW, no matter what the frame type
(known/unknown unicast or broadcast). This is how the frame source
information is propagated across the VPLS. So in the H-VPLS example, the
PE-r will never forward a frame received over a root PW on any leaf PW,
only on root PWs (toward the core or toward other spokes).

Daniel

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf
Of Alexander Vainshtein

Sam, Lizhong and all,

If this is the case, what kind of forwarding logic should be used to
prevent sending a BUM frame received from a root-PW to a given MTU-S:
- back to the same MTU-S on the corresponding leaf-PW?
- twice (to both root-PW and Leaf-PW) to another MTU-s? And, BTW, how is
the PW selected in this case?

I am aware of a technique of multiple split horizon groups in PE-r which
could be possibly used for this purpose. However, since these groups
have to be represented explicitly in the data plane, their potential
number is limited by the forwarding HW. Other methods could be probably
used for the same purpose, but they would probably subject to similar
HW-based limitations.

I suspect that with the dual-PW approach, the HW would pose an implicit
limit, say, on a number of MTU-s that can be connected to the same PE-r
and that this limit could be quite low in most cases.

Based on this I suspect that the H-VPLS issue as a critical drawback of
the dual-PW approach to E-Tree.

My 2c,
     Sasha

________________________________________
From: [email-masked] [[email-masked]] on behalf of Sam
Cao [[email-masked]]
Sent: Wednesday, May 09, 2012 3:40 AM
To: [email-masked]
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Lizhong?

[Lizhong] agree with the above analysis. And we did not say it is a
technical problem, but it is an operational problem again.
[Sam] I agree. Dual-VLAN does not make sense. I also discussed this with
Giles and Yuanlong in another mail, and we reached agreement on this:
MTU should know the access mode, VPWS or VPLS, VPWS mode should
configure VLAN ID on MTU but VPLS mode can not. I thought this is NOT
reasonable :), but we can figure this out in draft. It seems ok.

[Lizhong] not fully understand. Do you mean,  when VPWS accessing for
H-VPLS, the PE-r is also necessary to configure two PWs (root and leaf
PW) for each AC access?
[Sam] Yes.

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Mon, 14 May 2012 08:36:05 +0000

Daniel, please see my comments in line.

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] So in the reverse direction, you need to transport both root and leaf traffic from PE-rs over a root PW to PE-r, and transport root traffic over a leaf PW. It seems against the definition of root PW and leaf PW in the multi-PW draft. Don't this make the forwarding plane of PE-rs more complex? 

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Daniel Cohn" <[email-masked]>
Date: Mon, 14 May 2012 12:00:09 +0300

Hi Yuanlong,

Like I wrote below, root/leaf spoke PW behave like root/leaf AC, not
like root/spoke "core PW". So no changes to forwarding plane once this
is understood.

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] So in the reverse direction, you need to transport both root and
leaf traffic from PE-rs over a root PW to PE-r, and transport root
traffic over a leaf PW. It seems against the definition of root PW and
leaf PW in the multi-PW draft. Don't this make the forwarding plane of
PE-rs more complex? 

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Mon, 14 May 2012 11:09:51 +0000

Hi Daniel,

Fine, now it seems more in line with what we had proposed in 2VLAN: a spoke PW behaves like root/leaf AC for a PE-r.

But the same problem may also apply to the root/spoke "core PW" for Multi-PW:
According to Multi-PW, only one PW is required between two PEs except when both PEs are mixed with root and leaf, so these PWs may be formed by combinations of the following unidirectional PW cases (extracted and adapted from Josh's email):
Root-only -> any VSI = one root PW
Leaf-only -> root-only = one leaf PW
Leaf-only -> mixed = one leaf PW 
Mixed -> root-only = one (root+leaf) PW           
Mixed -> leaf-only = one (root+leaf) PW  

I have a concern that the forwarding plane of PE to implement this will be very different from the traditional VPLS.

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Mon, 14 May 2012 20:31:05 +0800

Hi Yuanlong,

We have discussed this in another thread. In fact, Daniel or I have given
the answers to the questions you raised here for several time :). If we do
in this way, we will reach deadlock and can not move forward :). I try to
explain it again.

As you know, initial design we will setup 2 PWs all the time (if do in this
way, I think that you have no question), but in most cases 2 PWs are not
necessary. So in 01 version, we optimize it.

"Root-only VSI <-> any VSI: only root PW required"
"Leaf-only VSI <-> leaf-only VSI: no PWs required"

In other cases 2 PWs are needed. If so, "Leaf-only -> root-only = one leaf
PW" is not correct: On Leaf-only side, yes, one Leaf-only PW is created
between Local Leaf type with remote Root type; on root-only side, one
root-only PW is created. Maybe it is better to call this as compatible or
mixed PW. So the left items you list are not correct for multi_PW solution.

BTW, I guess you also care this case we also have discussed before: for
example, if we configure one Leaf AC on root-only PE (then it will be
root-leaf-mixed PE), we will teardown the compatible PW and re-setup PWs
again with 01. 

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Fine, now it seems more in line with what we had proposed in 2VLAN: a spoke
PW behaves like root/leaf AC for a PE-r.

But the same problem may also apply to the root/spoke "core PW" for
Multi-PW:
According to Multi-PW, only one PW is required between two PEs except when
both PEs are mixed with root and leaf, so these PWs may be formed by
combinations of the following unidirectional PW cases (extracted and adapted
from Josh's email):
Root-only -> any VSI = one root PW
Leaf-only -> root-only = one leaf PW
Leaf-only -> mixed = one leaf PW 
Mixed -> root-only = one (root+leaf) PW           
Mixed -> leaf-only = one (root+leaf) PW  

I have a concern that the forwarding plane of PE to implement this will be
very different from the traditional VPLS.

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Tue, 15 May 2012 02:26:45 +0000

Please see my comments in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] I will apologize if you had ever provided such answers before, and you may just refer to the links rather than repeat the explanation.
As you can see, I just try to understand the mechanism of 2PW and its implications, but the I-D does not include enough information.

As you know, initial design we will setup 2 PWs all the time (if do in this
way, I think that you have no question), 

[JY] I will be concerned with the operational complexity of this approach.

but in most cases 2 PWs are not
necessary. So in 01 version, we optimize it.

[JY] This is something new, right? To be honest, I could not understand what is your point: doesn't the mixed PW as you called also consist of one Leaf-only PW in one direction and one root-only PW in the other direction? Furthermore, the case you took is also one case in your guideline "Root-only VSI <-> any VSI: only root PW required", don't you think that only one root PW is required following this guideline?
Actually, I don't care much about what is the bidirectional PW or unidirectional PW called, but how can a VSI support such a mixed scenarios: traditional VSI assumes only one PW is required for each peer VSI, and its MAC leaning is based on bidirectional PW. But for 2PW, there are bidirectional root PW, bidirectional leaf PW, mixed PW, etc..., how to support these kinds of PWs in the same VSI is my top concern.

BTW, I guess you also care this case we also have discussed before: for
example, if we configure one Leaf AC on root-only PE (then it will be
root-leaf-mixed PE), we will teardown the compatible PW and re-setup PWs
again with 01. 
[JY] This was discussed in the emails indeed.

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Tue, 15 May 2012 13:08:36 +0800

Hi Yuanlong,

Good point. Thank you very much for your comments. Wish I can clarify it
this time.

[JY] This is something new, right? To be honest, I could not understand what
is your point: doesn't the mixed PW as you called also consist of one
Leaf-only PW in one direction and one root-only PW in the other direction?
Furthermore, the case you took is also one case in your guideline "Root-only
VSI <-> any VSI: only root PW required", don't you think that only one root
PW is required following this guideline?
[Sam] This may confuse this. This PW is only PW between the 2 PEs. Here we
call it as Root-PW, but maybe compatible PW is good name for it. I clarify
this below.

Actually, I don't care much about what is the bidirectional PW or
unidirectional PW called, but how can a VSI support such a mixed scenarios:
traditional VSI assumes only one PW is required for each peer VSI, and its
MAC leaning is based on bidirectional PW. But for 2PW, there are
bidirectional root PW, bidirectional leaf PW, mixed PW, etc..., how to
support these kinds of PWs in the same VSI is my top concern.

[Sam] Before Paris meeting, Giles initiated discussions among all co-authors
of E-Tree drafts. During that time some members raised PW operations and
commented that there are seldom Root-Leaf-Mixed PEs in an E-Tree, so
multi-PW-01 optimize PW setup. This is the history.

Ok, we go on the case in your mail, where PE1 has one Root-only AC, AC1, and
PE2 has one Leaf-only AC, AC2. In general we can setup 2 "unidirectional"
PWs (bidirectional PW, but just carry unidirectional frames), Root-PW which
carries frames originated from AC1 and Leaf-PW which carries frames
originated from AC2. But only one PW also can work, just as some members
commented. Ok, we setup one PW between PE1 and PE2, we can call this PW as
compatible PW or something else. Frames originated from Root or leaf ACs
will be carried via this PW. Its forwarding behavior is fully same as what
traditional VPLS did, MAC learning on AC or PW in one E-Tree. Or say, if one
PE has Root-only ACs, it will setup one PW with another PE, Root-only,
Leaf-only or Root-Leaf-Mixed. If 2 PEs are root-Leaf-Mixed or other cases,
then 2 PWs will be established. As you know, this can be done on control
plane. 

Is this clear for you? Is this necessary to optimize PW setup in this case? 

Maybe we need to add one paragraph on forwarding behavior. 

Again thank you very much for your comments,

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] I will apologize if you had ever provided such answers before, and you
may just refer to the links rather than repeat the explanation.
As you can see, I just try to understand the mechanism of 2PW and its
implications, but the I-D does not include enough information.

[JY] This is something new, right? To be honest, I could not understand what
is your point: doesn't the mixed PW as you called also consist of one
Leaf-only PW in one direction and one root-only PW in the other direction?
Furthermore, the case you took is also one case in your guideline "Root-only
VSI <-> any VSI: only root PW required", don't you think that only one root
PW is required following this guideline?
Actually, I don't care much about what is the bidirectional PW or
unidirectional PW called, but how can a VSI support such a mixed scenarios:
traditional VSI assumes only one PW is required for each peer VSI, and its
MAC leaning is based on bidirectional PW. But for 2PW, there are
bidirectional root PW, bidirectional leaf PW, mixed PW, etc..., how to
support these kinds of PWs in the same VSI is my top concern.

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Tue, 15 May 2012 07:32:19 +0000

Sam,

Thanks, please see my further comments with [JY].

[JY] Assume there are 2 other nodes PE3 & PE4 in this network scenario, and both PE3 and PE4 have both root and leaf ACs, then there are compatible PWs from PE3 which may carry both root and leaf traffic (to PE1), which may carry only root traffic (to PE2); and further there are root PW and leaf PW to PE4. Thus, the VSI on PE3 has at least 4 different types of PW transmitting behaviours with regard to the E-Tree traffic. In the reverse direction, the VSI on PE3 further has at least 4 different types of PW receiving behaviours. Not sure how you will accommodate for these PWs in both the data plane and control plane.

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Tue, 15 May 2012 18:14:24 +0800

Hi Yuanlong,

Thank you very much for your comments. I draw the topology you gave, and 7
PWs will be established if we follow 01.

Root AC ---- PE 1 ----- PW 1 -------- PE 2 ----- Leaf _AC
               |  \                 /  ||
               |   \  /===PW 6,7===    ||
	          PW 2  -----PW 5------\  ||
               |  /----Root PW 3 --- \ ||
Root _AC ---- PE 3                    PE 4 ------ Root AC
               |   \                  /  |
               |    ----Leaf PW 4-----   | 
            Leaf AC                    Leaf AC
Yes, on PE 3 there are several PWs, but if you want to clarify it, there are
only 3 types, one can carry frames originated from Root and Leaf AC(one
endpoint of this PW should be Root-only, otherwise this is invalid), one
only can carry frames from Root AC, and the last can carry frames from Leaf
ACs. On second thoughts, we still can classify the PWs into 2 sets, one is
Leaf set, and another is Root set, and the union of the sets Leaf and Root
is the PW we called it as compatible PW (Maybe this is not correct, we can
find one good term on this). 

So this optimization still follows the original design of Dual-PW approach,
Leaf PW only carries frames from Leaf AC; Root-PW only carries frames from
Root AC. Is it right?

I don't know whether chip can support this forwarding behavior for
compatible PW or not, but if we implement it in NP, it is nearly same as
VPLS. The only difference is, setup 2 mappings, one between Leaf-ACs and
Leaf-PWs, one between Root-ACs and Root-PWs. For traditional VPLS, there is
only one mapping. 

Based on my understanding, all drafts should have similar mapping. 

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

[JY] Assume there are 2 other nodes PE3 & PE4 in this network scenario, and
both PE3 and PE4 have both root and leaf ACs, then there are compatible PWs
from PE3 which may carry both root and leaf traffic (to PE1), which may
carry only root traffic (to PE2); and further there are root PW and leaf PW
to PE4. Thus, the VSI on PE3 has at least 4 different types of PW
transmitting behaviours with regard to the E-Tree traffic. In the reverse
direction, the VSI on PE3 further has at least 4 different types of PW
receiving behaviours. Not sure how you will accommodate for these PWs in
both the data plane and control plane.

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Tue, 15 May 2012 11:03:30 +0000

See my further comments in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 6:14 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] It seems you may need a 3rd mapping: from both root & leaf AC to a compatible PW.
BTW, for the forwarding and reverse direction, the mapping may be asymmetric for you compatible PW.

[JY] Dual-VLAN seems simpler here.

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Tue, 15 May 2012 21:32:02 +0800

Hi Yuanlong,

3rd mapping will make data plane complex, I think. Anyway, we reached a
consensus on Multi-PW implementation. 

If we use 3rd mapping, I agree with your opinion, maybe dual-VLAN seems
simple, but 2 mapping is enough. Then we can focus on data plane
performance. While stripe PW label out on egress PE, data-plane knows how to
forward the frames from PW, to Root AC or Leaf AC or all. But if we use
Dual-VLAN, after strip PW label out, data plane should strip VLAN-ID out and
then does same forwarding work as Multi-PW does. The most important is, do
one more operation while forwarding E-Tree frames. Obviously the forwarding
performance of Dual-VLAN will be much lower than what of Multi-PW.

Regards,
 
Yuqun (Sam) Cao

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 6:14 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

[JY] It seems you may need a 3rd mapping: from both root & leaf AC to a
compatible PW.
BTW, for the forwarding and reverse direction, the mapping may be asymmetric
for you compatible PW.

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Balus, Florin Stelian (Florin)" <[email-masked]>
Date: Tue, 15 May 2012 14:52:35 -0500

Sam,

> Obviously the forwarding performance of Dual-VLAN will be much lower than what of Multi-PW.

Sorry I could not keep up with some of the threads on this subject but the above statement caught my eyes. We have been doing all kind of egress operations on VLANs in the egress PE for the last 8 years and I am not aware of any "much lower" forwarding performance. As far as I know the chipsets used in the PEs can do this processing no problem. Do you want to clarify which kind of hardware may have problems?

> Of Sam Cao
> Sent: Tuesday, May 15, 2012 6:32 AM
> To: 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'
> Cc: [email-masked]
> Subject: RE: Discussion on forwarding performance
>
> Hi Yuanlong,
>
> performance. While stripe PW label out on egress PE, data-plane knows
> how to forward the frames from PW, to Root AC or Leaf AC or all. But if
> we use Dual-VLAN, after strip PW label out, data plane should strip
> VLAN-ID out and then does same forwarding work as Multi-PW does. The
> most important is, do one more operation while forwarding E-Tree
> frames. Obviously the forwarding performance of Dual-VLAN will be much
> lower than what of Multi-PW.
>
> Regards,
>
> Yuqun (Sam) Cao
> Thank you very much for your comments. I draw the topology you gave,
> and 7 PWs will be established if we follow 01.
>
> Yes, on PE 3 there are several PWs, but if you want to clarify it,
> there are only 3 types, one can carry frames originated from Root and
> Leaf AC(one endpoint of this PW should be Root-only, otherwise this is
> invalid), one only can carry frames from Root AC, and the last can
> carry frames from Leaf ACs. On second thoughts, we still can classify
> the PWs into 2 sets, one is Leaf set, and another is Root set, and the
> union of the sets Leaf and Root is the PW we called it as compatible PW
> (Maybe this is not correct, we can find one good term on this).
>
> So this optimization still follows the original design of Dual-PW
> approach, Leaf PW only carries frames from Leaf AC; Root-PW only
> carries frames from Root AC. Is it right?
>
> compatible PW or not, but if we implement it in NP, it is nearly same
> as VPLS. The only difference is, setup 2 mappings, one between Leaf-ACs
> and Leaf-PWs, one between Root-ACs and Root-PWs. For traditional VPLS,
> there is only one mapping.
>
> PWs (bidirectional PW, but just carry unidirectional frames), Root-PW
> which carries frames originated from AC1 and Leaf-PW which carries
> frames originated from AC2. But only one PW also can work, just as some
> members commented. Ok, we setup one PW between PE1 and PE2, we can call
> this PW as compatible PW or something else. Frames originated from Root
> or leaf ACs will be carried via this PW. Its forwarding behavior is
> fully same as what traditional VPLS did, MAC learning on AC or PW in
> one E-Tree. Or say, if one PE has Root-only ACs, it will setup one PW
> with another PE, Root-only, Leaf-only or Root-Leaf-Mixed. If 2 PEs are
> root-Leaf-Mixed or other cases, then 2 PWs will be established. As you
> know, this can be done on control plane.
>
> [JY] Assume there are 2 other nodes PE3 & PE4 in this network scenario,
> and both PE3 and PE4 have both root and leaf ACs, then there are
> compatible PWs from PE3 which may carry both root and leaf traffic (to
> PE1), which may carry only root traffic (to PE2); and further there are
> root PW and leaf PW to PE4. Thus, the VSI on PE3 has at least 4
> different types of PW transmitting behaviours with regard to the E-Tree
> traffic. In the reverse direction, the VSI on PE3 further has at least
> 4 different types of PW receiving behaviours. Not sure how you will
> accommodate for these PWs in both the data plane and control plane.
>
> Regards,
> Yuanlong
>
> We have discussed this in another thread. In fact, Daniel or I have
> given the answers to the questions you raised here for several time :).
> If we do in this way, we will reach deadlock and can not move forward
> :). I try to explain it again.
>
> [JY] I will apologize if you had ever provided such answers before, and
> you may just refer to the links rather than repeat the explanation.
> As you know, initial design we will setup 2 PWs all the time (if do in
> this way, I think that you have no question),
>
> In other cases 2 PWs are needed. If so, "Leaf-only -> root-only = one
> leaf PW" is not correct: On Leaf-only side, yes, one Leaf-only PW is
> created between Local Leaf type with remote Root type; on root-only
> side, one root-only PW is created. Maybe it is better to call this as
> compatible or mixed PW. So the left items you list are not correct for
> multi_PW solution.
>
> [JY] This is something new, right? To be honest, I could not understand
> what is your point: doesn't the mixed PW as you called also consist of
> one Leaf-only PW in one direction and one root-only PW in the other
> direction?
> Furthermore, the case you took is also one case in your guideline
> "Root-only VSI <-> any VSI: only root PW required", don't you think
> that only one root PW is required following this guideline?
> traditional VSI assumes only one PW is required for each peer VSI, and
> its MAC leaning is based on bidirectional PW. But for 2PW, there are
> root-leaf-mixed PE), we will teardown the compatible PW and re-setup
> PWs again with 01.
> Fine, now it seems more in line with what we had proposed in 2VLAN: a
> spoke PW behaves like root/leaf AC for a PE-r.
>
> According to Multi-PW, only one PW is required between two PEs except
> when both PEs are mixed with root and leaf, so these PWs may be formed
> by combinations of the following unidirectional PW cases (extracted and
> adapted from Josh's email):
> I have a concern that the forwarding plane of PE to implement this will
> be very different from the traditional VPLS.
>
> Regards,
> Yuanlong
>
> root/leaf ACs. So when leaf-originated BUM traffic arrives from the
> core (over a leaf PW), it will be forwarded over all root spoke PWs but
> not on the leaf spoke PWs.
>
> example, if the PE-r is attached with 9 leafs, then the BUM traffic
> from one of its leafs will be multiplied by 8 times, and be forwarded
> by the PE-rs to the same PE-r).
> information is propagated across the VPLS. So in the H-VPLS example,
> the PE-r will never forward a frame received over a root PW on any leaf
> PW, only on root PWs (toward the core or toward other spokes).
>
> I am aware of a technique of multiple split horizon groups in PE-r
> which could be possibly used for this purpose. However, since these
> groups have to be represented explicitly in the data plane, their
> potential number is limited by the forwarding HW. Other methods could
> be probably used for the same purpose, but they would probably subject
> to similar HW-based limitations.
>
> [Sam] I agree. Dual-VLAN does not make sense. I also discussed this
> with Giles and Yuanlong in another mail, and we reached agreement on
> this:

---

From: David Allan I <[email-masked]>
Date: Tue, 15 May 2012 15:55:27 -0400

Florin:

I agree. The statement, at least to me, is a non-sequitor...

Cheers
Dave

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Balus, Florin Stelian (Florin)
Sent: Tuesday, May 15, 2012 12:53 PM
To: Sam Cao; 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Sam,

> 3rd mapping will make data plane complex, I think. Anyway, we reached
> a consensus on Multi-PW implementation.
>
> If we use 3rd mapping, I agree with your opinion, maybe dual-VLAN
> seems simple, but 2 mapping is enough. Then we can focus on data plane
> how to forward the frames from PW, to Root AC or Leaf AC or all. But
> if we use Dual-VLAN, after strip PW label out, data plane should strip
> union of the sets Leaf and Root is the PW we called it as compatible
> PW (Maybe this is not correct, we can find one good term on this).
>
> as VPLS. The only difference is, setup 2 mappings, one between
> Leaf-ACs and Leaf-PWs, one between Root-ACs and Root-PWs. For
> traditional VPLS, there is only one mapping.
>
> frames originated from AC2. But only one PW also can work, just as
> some members commented. Ok, we setup one PW between PE1 and PE2, we
> can call this PW as compatible PW or something else. Frames originated
> from Root or leaf ACs will be carried via this PW. Its forwarding
> behavior is fully same as what traditional VPLS did, MAC learning on
> AC or PW in one E-Tree. Or say, if one PE has Root-only ACs, it will
> setup one PW with another PE, Root-only, Leaf-only or Root-Leaf-Mixed.
> If 2 PEs are root-Leaf-Mixed or other cases, then 2 PWs will be
> established. As you know, this can be done on control plane.
>
> [JY] Assume there are 2 other nodes PE3 & PE4 in this network
> scenario, and both PE3 and PE4 have both root and leaf ACs, then there
> are compatible PWs from PE3 which may carry both root and leaf traffic
> (to PE1), which may carry only root traffic (to PE2); and further
> there are root PW and leaf PW to PE4. Thus, the VSI on PE3 has at
> least 4 different types of PW transmitting behaviours with regard to
> the E-Tree traffic. In the reverse direction, the VSI on PE3 further
> has at least
> [JY] I will apologize if you had ever provided such answers before,
> and you may just refer to the links rather than repeat the explanation.
> [JY] This is something new, right? To be honest, I could not
> understand what is your point: doesn't the mixed PW as you called also
> consist of one Leaf-only PW in one direction and one root-only PW in
> the other direction?
> BTW, I guess you also care this case we also have discussed before:
> for example, if we configure one Leaf AC on root-only PE (then it will
> be root-leaf-mixed PE), we will teardown the compatible PW and
> re-setup PWs again with 01.
> by combinations of the following unidirectional PW cases (extracted
> and adapted from Josh's email):
> Mixed -> root-only = one (root+leaf) PW Mixed -> leaf-only = one
> (root+leaf) PW
>
> I have a concern that the forwarding plane of PE to implement this
> will be very different from the traditional VPLS.
>
> Regards,
> Yuanlong
>
> core (over a leaf PW), it will be forwarded over all root spoke PWs
> but not on the leaf spoke PWs.
>
> When you set up two PWs from the PE-rs to a PE-r for each of its AC,
> do you mean that one PW is bidirectional root PW and the other is
> bidirectional leaf PW?
> the PE-r will never forward a frame received over a root PW on any
> leaf PW, only on root PWs (toward the core or toward other spokes).
>
> You've written that in the two-PW solution combined with H-VPLS the
> PE- r must set up two PWs with each MTU-s.
>
> I suspect that with the dual-PW approach, the HW would pose an
> implicit limit, say, on a number of MTU-s that can be connected to the
> same PE-r and that this limit could be quite low in most cases.
>

---

From: Lucy yong <[email-masked]>
Date: Tue, 15 May 2012 20:15:02 +0000

+1

We can't just make a conclusion from nowhere.

Lucy

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of David Allan I
Sent: Tuesday, May 15, 2012 2:55 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Florin:

Cheers
Dave

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Balus, Florin Stelian (Florin)
Sent: Tuesday, May 15, 2012 12:53 PM
To: Sam Cao; 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Sam,

---

From: "Sam Cao" <[email-masked]>
Date: Wed, 16 May 2012 10:09:08 +0800

Lucy/David/Florin,

Thank you very much for your comments. 

I can not give the accurate data to support my conclusion, and just conclude
that if we implement it in NP module. Except for common operations of 2
approaches, Tunnel Label push/pop-out, MAC-based forwarding, and etc.,
Dual-VLAN needs one more VLAN push/pop-out operation while forwarding every
frame. So compared with Multi-PW, it needs more resource and time for NP
module if there are VSIs or PWs up limit to the capacity on one PE, and
standing on software architect's side, the performance will be decreased by
at least 20%, I guess. I implemented one prototype which has similar
solution as current Multi-PW, and the performance will be decreased by 5%,
compared with traditional VPLS. Daniel has experience on 2-PW deployment,
maybe he can give accurate data on Multi-PW.

Florin, do you mean that you have implemented E-Tree in MPLS network? If
chipset can support this and we don't care NP or other solutions, yes, we
can ignore any side effect on forwarding performance. Yes, it can support
E-tree in IP (Ethernet) network, but I read some CHIP datasheets, after
strip PW label out, chip can not handle 2 VLAN IDs at same time. Could you
please give me some hints, say, which chip you used?

Maybe if we raised only one issue in one mail, we can get more and insight
comments :). I will raise another after we agree with this in the main :). 

Thanks,

Sam

-----Original Message-----
From: Lucy yong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:15 AM
To: David Allan I; Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong;
'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

+1

Lucy

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
David Allan I
Sent: Tuesday, May 15, 2012 2:55 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; 'Daniel Cohn';
'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Florin:

Cheers
Dave

-----Original Message-----
Balus, Florin Stelian (Florin)

Sam,

> Obviously the forwarding performance of Dual-VLAN will be much lower than
what of Multi-PW.

Sorry I could not keep up with some of the threads on this subject but the
above statement caught my eyes. We have been doing all kind of egress
operations on VLANs in the egress PE for the last 8 years and I am not aware
of any "much lower" forwarding performance. As far as I know the chipsets
used in the PEs can do this processing no problem. Do you want to clarify
which kind of hardware may have problems?

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 02:17:04 +0000

If we use 3rd mapping, I agree with your opinion, maybe dual-VLAN seems
simple, but 2 mapping is enough. 

[JY] Can't see how 2 mapping is enough for 2PW, do you mean to use 2 PWs for all the peer PEs?

Then we can focus on data plane
performance. While stripe PW label out on egress PE, data-plane knows how to
forward the frames from PW, to Root AC or Leaf AC or all. But if we use
Dual-VLAN, after strip PW label out, data plane should strip VLAN-ID out and
then does same forwarding work as Multi-PW does. 

[JY] We are running into the same cycle: forward implications for 2PW was already covered in http://www.ietf.org/mail-archive/web/l2vpn/current/msg03513.html, no need to repeat it here.

The most important is, do
one more operation while forwarding E-Tree frames. Obviously the forwarding
performance of Dual-VLAN will be much lower than what of Multi-PW.

[JY] VLAN operation is generally available in VPLS already, does this statement also mean Multi-PW will have a much higher performance even compared with VPLS itself?

Regards,
 
Yuqun (Sam) Cao

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 6:14 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 02:45:40 +0000

See my comments in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:09 AM
To: Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)'; Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Lucy/David/Florin,

[JY] So you have no NP implementation either for Dual-VLAN or Multi-PW... but why do you think the performance will be decreased by at least 20%?
I also have some experiences in NP programming, it must be a big surprise that one more VLAN push/pop-out operation will incur a penalty of performance degradation of 20%. 

[JY] the chip doesn't need to handle 2 VLAN IDs at same time, see the previous msg: http://www.ietf.org/mail-archive/web/l2vpn/current/msg03392.html

Thanks,

Sam

-----Original Message-----
From: Lucy yong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:15 AM
To: David Allan I; Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong;

+1

Lucy

-----Original Message-----

Florin:

Cheers
Dave

-----Original Message-----

Sam,

---

From: "Sam Cao" <[email-masked]>
Date: Wed, 16 May 2012 10:49:51 +0800

Yes, Yuanlong. We have discussed this before, but I can not get clear
conclusion till now. From that linkage I also can not find it.

Compared to traditional VPLS, forwarding performance of all solutions will
be decreased. If chip can fully support the solutions and we ignore other
non-chip solution, we can ignore forwarding performance. But can we ignore
it?

I found your patent application on this, and think that we need to re-design
VLAN Bridge you mentioned. VLAN Bridge can not support this inherently :).

BTW, Yuanlong, is there any experimental data on forwarding performance?

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:17 AM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

[JY] Can't see how 2 mapping is enough for 2PW, do you mean to use 2 PWs for
all the peer PEs?

[JY] We are running into the same cycle: forward implications for 2PW was
already covered in
http://www.ietf.org/mail-archive/web/l2vpn/current/msg03513.html, no need to
repeat it here.

[JY] VLAN operation is generally available in VPLS already, does this
statement also mean Multi-PW will have a much higher performance even
compared with VPLS itself?

Regards,
 
Yuqun (Sam) Cao

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 6:14 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: Loa Andersson <[email-masked]>
Date: Wed, 16 May 2012 04:57:44 +0200

Folks,

an innocent question since I it is a long time since I worked with
forwarding performance, I lost most of the interest when it was clear
that whichever we used we could forward at wire speed.

There has been other discussions around how many label look up certain
hw can handle, but I thought we were past this point also.

Would one extra label cause us to drop below wire speed in forwarding
performance? Is this mostly a implementation complexity issue?

/Loa

On 2012-05-16 04:49, Sam Cao wrote:
> [JY] It seems you may need a 3rd mapping: from both root&  leaf AC to a
> compatible PW.
> [JY] Assume there are 2 other nodes PE3&  PE4 in this network scenario, and
> "Root-only VSI<->  any VSI: only root PW required"
> "Leaf-only VSI<->  leaf-only VSI: no PWs required"
>
> VSI<->  any VSI: only root PW required", don't you think that only one root
> From: "Daniel Cohn"<[email-masked]>
> To: "Alexander Vainshtein"<[email-masked]>,	"Sam
> 	Cao"<[email-masked]>,<[email-masked]>
> Message-ID:<44F4E579A764584EA9BDFD07D0CA08130780CBA6@tlvmail1>

-- 

Loa Andersson                         email: [email-masked]
Sr Strategy and Standards Manager            [email-masked]
Ericsson Inc                          phone: +46 10 717 52 13
                                              +46 767 72 92 13

---

From: "Sam Cao" <[email-masked]>
Date: Wed, 16 May 2012 11:37:30 +0800

Loa,

1) This question comes from remaining issues list in past threads, raised by
other members, and I can not find any agreement on this.

2) If the E-tree frames are fully forwarded via chip, we could forward at
wire speed, so I also mentioned in that mail "If chipset can support this
and we don't care NP or other solutions, yes, we can ignore any side effect
on forwarding performance". But in some cases we can not forward at wire
speed. Does my test result mislead me? 

Loa, can you get forwarding parameters from some Router's datasheet? Thank
you very much for your comments,

Sam

-----Original Message-----
From: Loa Andersson [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:58 AM
To: Sam Cao
Cc: 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'; [email-masked]
Subject: Re: Discussion on forwarding performance

Folks,

/Loa

> So this optimization still follows the original design of Dual-PW
approach,
> PWs (bidirectional PW, but just carry unidirectional frames), Root-PW
which
> [JY] I will apologize if you had ever provided such answers before, and
you
> As you know, initial design we will setup 2 PWs all the time (if do in
this
> In other cases 2 PWs are needed. If so, "Leaf-only ->  root-only = one
leaf
> [JY] This is something new, right? To be honest, I could not understand
what
> Furthermore, the case you took is also one case in your guideline
"Root-only
> Fine, now it seems more in line with what we had proposed in 2VLAN: a
spoke

--

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 03:59:24 +0000

See in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:50 AM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

[JY] the linkage analyzed the implications of Multi-PW in forwarding, it is not so simple as "data-plane knows how to
forward the frames from PW, to Root AC or Leaf AC or all." 

[JY] no, we will not ignore them. But there is no evidence that it is much different in performance comparison.

[JY] VLAN bridge with E-Tree support is standardized in IEEE already. 

[JY] please see the off the shelf PE routers with the same support of VLAN operations just as described in RFC 6246.

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:17 AM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Regards,
 
Yuqun (Sam) Cao

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 6:14 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Thanks,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 3:32 PM
To: Sam Cao; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Sam,

Regards,
Yuanlong

Sam

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 8:31 PM
To: Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,
 
Yuqun (Sam) Cao
 
-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 7:10 PM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 5:00 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

DC

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Monday, May 14, 2012 3:37 PM
To: Jiangyuanlong; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Yuanlong,

Regards,

Daniel

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Friday, May 11, 2012 5:03 AM
To: Daniel Cohn; Alexander Vainshtein; Sam Cao
Cc: [email-masked]
Subject: RE: Discussion on E-Tree and H-VPLS

Hi Daniel and all,

Thanks,
Yuanlong

Hi Sasha,

Daniel

-----Original Message-----

Sam, Lizhong and all,

My 2c,
     Sasha

Hi Lizhong?

Thanks,

Sam

---

From: "Sam Cao" <[email-masked]>
Date: Wed, 16 May 2012 12:06:21 +0800

Yuanlong,

I have no NP implementation either for Dual-VLAN or Multi-PW since there is
no resource on this :). This is just my guess on software side, not accurate
data.

I shared my tester experience data on IP frame forwarding with VPLS frame
forwarding. In back-to-back topology: VPLS frame forwarding performance is
about 80% of IP frame forwarding performance. Yuanlong, I think you also
have such data since you have experience on NP and developers should care
this. Again, if work on chip, we can ignore site effect on forwarding
performance.

Maybe we can improve software architecture, but I guess there is a little
side effect on Multi-PW, but more on Dual-VLAN. Yuanlong, Is there any
authoritative data on this?

Anyway, if we need, I want to ask some co-workers to get the forwarding
difference between IP forwarding and VPLS forwarding on some vendor's
routers, but it needs a little time and human resource^_^.

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:46 AM
To: Sam Cao; Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)';

See my comments in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:09 AM
To: Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)';
Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Lucy/David/Florin,

[JY] So you have no NP implementation either for Dual-VLAN or Multi-PW...
but why do you think the performance will be decreased by at least 20%?
I also have some experiences in NP programming, it must be a big surprise
that one more VLAN push/pop-out operation will incur a penalty of
performance degradation of 20%. 

[JY] the chip doesn't need to handle 2 VLAN IDs at same time, see the
previous msg:
http://www.ietf.org/mail-archive/web/l2vpn/current/msg03392.html

Thanks,

Sam

-----Original Message-----
From: Lucy yong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:15 AM
To: David Allan I; Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong;

+1

Lucy

-----Original Message-----

Florin:

Cheers
Dave

-----Original Message-----

Sam,

---

From: Loa Andersson <[email-masked]>
Date: Wed, 16 May 2012 06:15:12 +0200

Sam,

sorry for jumping in late - I will look into if there are available
forwarding parameters that I can share.

Do I understand you correctly if you say that for a chip we will be
able to do wire line forwarding for any number of labels that we
reasonably can expect to handle?

A NP will hit the limit earlier, and for E-tree this [is, might be] an
issue.

/Loa

--

---

From: "Balus, Florin Stelian (Florin)" <[email-masked]>
Date: Tue, 15 May 2012 23:29:31 -0500

Sam,

> maybe he can give accurate data on Multi-PW.
FB> Are you saying there are already largescale deployment of the 2-PW solution. Would like to hear from service providers running the solution...
>
> Florin, do you mean that you have implemented E-Tree in MPLS network?
FB> Proprietary ETREE solutions are available from a number of vendors, some involving filtering based on inner payload.... But that was not the pointof my comment. I was saying a number of implementations are available that operate on VLANs without performance hit.
> If

FB> this is not the place to advertise hardware capabilities... If you search the archive though about an year ago a well known chip vendor expressed support for the vlan based solution.

Florin

---

From: Jeff Tantsura <[email-masked]>
Date: Wed, 16 May 2012 00:56:25 -0400

Hi,

To my knowledge most of commercially available silicon can do upto 4 labels lookup without affecting FW performance.
That's also why entropy label shouldn't be places too deep in the stack in order not to affect performance.

Regards,
Jeff

---

From: "Daniel Cohn" <[email-masked]>
Date: Wed, 16 May 2012 09:16:10 +0300

Hi,

I agree that for a chip-based solution there should be no difference in
performance for the additional lookup. However from conversations with
chip vendors, I understood there might be an impact on scalability
because the double lookup would require a longer search key (assuming
VLAN and VCID lookups are performed simultaneously on ingress), thus
taking up more TCAM resources per E-Tree instance. This would depend on
specific TCAM implementation (e.g. granularity of search key length).

DC

-----Original Message-----
From: Balus, Florin Stelian (Florin)
[mailto:[email-masked]] 
Sent: Tuesday, May 15, 2012 10:53 PM
To: Sam Cao; 'Jiangyuanlong'; Daniel Cohn; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Sam,

> Obviously the forwarding performance of Dual-VLAN will be much lower
than what of Multi-PW.

Sorry I could not keep up with some of the threads on this subject but
the above statement caught my eyes. We have been doing all kind of
egress operations on VLANs in the egress PE for the last 8 years and I
am not aware of any "much lower" forwarding performance. As far as I
know the chipsets used in the PEs can do this processing no problem. Do
you want to clarify which kind of hardware may have problems?

> 3rd mapping will make data plane complex, I think. Anyway, we reached
a
> If we use 3rd mapping, I agree with your opinion, maybe dual-VLAN
seems
> how to forward the frames from PW, to Root AC or Leaf AC or all. But
if
> union of the sets Leaf and Root is the PW we called it as compatible
PW
> as VPLS. The only difference is, setup 2 mappings, one between
Leaf-ACs
> frames originated from AC2. But only one PW also can work, just as
some
> [JY] Assume there are 2 other nodes PE3 & PE4 in this network
scenario,
> [JY] I will apologize if you had ever provided such answers before,
and
> [JY] This is something new, right? To be honest, I could not
understand
> BTW, I guess you also care this case we also have discussed before:
for
> by combinations of the following unidirectional PW cases (extracted
and
> I have a concern that the forwarding plane of PE to implement this
will
> core (over a leaf PW), it will be forwarded over all root spoke PWs
but
> When you set up two PWs from the PE-rs to a PE-r for each of its AC,
do
leaf
> You've written that in the two-PW solution combined with H-VPLS the
PE-
> r must set up two PWs with each MTU-s.
>
implicit

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 06:31:48 +0000

What is the meaning of compare IP forwarding vs. VPLS forwarding? Both Dual-VLAN and Multi-PW approach reuse the VPLS forwarding and have nothing to do with IP forwarding. Did I miss something?

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 12:06 PM
To: Jiangyuanlong; Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)'; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Yuanlong,

Sam

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:46 AM
To: Sam Cao; Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)';

See my comments in line.

-----Original Message-----
From: Sam Cao [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 10:09 AM
To: Lucy yong; 'David Allan I'; 'Balus, Florin Stelian (Florin)';

Lucy/David/Florin,

Thanks,

Sam

-----Original Message-----
From: Lucy yong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:15 AM
To: David Allan I; Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong;

+1

Lucy

-----Original Message-----

Florin:

Cheers
Dave

-----Original Message-----

Sam,

---

From: Alexander Vainshtein <[email-masked]>
Date: Wed, 16 May 2012 06:42:46 +0000

Daniel, and all,
I am not sure that discussion of implementation-specific issues (e.g., whether you use or do not use TCAM lookups) really belongs to this list.

Regards,
     Sasha

> Sent: Wednesday, May 16, 2012 9:16 AM
> To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander
> Vainshtein
> Cc: [email-masked]
> > members commented. Ok, we setup one PW between PE1 and PE2, we
> can
> call

This e-mail message is intended for the recipient only and contains information which is CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this transmission in error, please inform us by e-mail, phone or fax, and then delete the original and all copies thereof.

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 06:43:28 +0000

Daniel, 

Not sure I fully understand what you mean by "VLAN and VCID lookups are performed simultaneously on ingress", do you mean VLAN and PW?
Can you give more details on this requirement?

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 2:16 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander Vainshtein
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Hi,

DC

-----Original Message-----

Sam,

a
seems
if
PW
Leaf-ACs
some
scenario,
and
understand
for
and
will
but
do
leaf
PE-
implicit

---

From: "Daniel Cohn" <[email-masked]>
Date: Wed, 16 May 2012 11:49:29 +0300

VC ID is another name for PW label, right.
<Sasha, stop your ears now> ;-)
>From conversations with chip vendors, I understood that when multiple
lookups are required (as in the dual-VLAN example, you need to lookup PW
label to identify E-Tree instance and then VLAN ID to identify root/leaf
origin), typically a single lookup is performed on ingress with a
composite search key (in this case, including PW label and VLAN ID). 
/<Sasha, stop your ears now> ;-)
But perhaps we are getting too much into implementation here. It would
be better if neutral NP and ASIC-based solution vendors could analyze
both solutions and confirm impact on performance and scalability - and
BTW, we also need input regarding existing silicon that doesn't support
VLAN mapping.

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 9:43 AM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel, 

Not sure I fully understand what you mean by "VLAN and VCID lookups are
performed simultaneously on ingress", do you mean VLAN and PW?
Can you give more details on this requirement?

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 2:16 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander
Vainshtein
Cc: [email-masked]

Hi,

DC

-----Original Message-----

Sam,

a
seems
if
PW
Leaf-ACs
some
scenario,
and
understand
for
and
will
but
do
leaf
PE-
implicit

---

From: Jiangyuanlong <[email-masked]>
Date: Wed, 16 May 2012 10:04:15 +0000

Daniel,

I don't think we need to look up the VLAN and PW at the same time for Dual-VLAN:
On the ingress PE, VLAN is firstly appended or translated for a incoming Ethernet frame from AC, then MAC forwarded in VSI to one or multiple logical ports each corresponding to a PW (the VLAN mapping may be processed on a logical port), finally a PW label is appended and transported over the corresponding PW.
On the egress PE, PW is popped and used to indicate a VSI (also corresponding to a logical port, where the VLAN mapping may also be processed), then MAC forwarded in VSI to one or multiple ports each corresponding to an AC (where a frame with a leaf VLAN will be dropped upon a leaf AC, actually, it is also a simple VLAN translation in IEEE, that is, from leaf VLAN to 0xFFF, and all frames with this VLAN will be dropped).

Therefore, double lookup of VLAN and PW seems unnecessary or even impossible for this service IMHO. 

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:49 PM
To: Jiangyuanlong; Balus, Florin Stelian (Florin); Sam Cao; Alexander Vainshtein
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 9:43 AM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel, 

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 2:16 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander
Vainshtein
Cc: [email-masked]

Hi,

DC

-----Original Message-----

Sam,

a
seems
if
PW
Leaf-ACs
some
scenario,
and
understand
for
and
will
but
do
leaf
PE-
implicit

---

From: "Daniel Cohn" <[email-masked]>
Date: Wed, 16 May 2012 13:30:14 +0300

Yuanlong,

I was referring always to the egress PE. In my understanding (going
deeper and deeper into implementation) an ASIC-based solution will
typically perform PW and VLAN lookup on ingress and as a result of the
lookup add internal tags to the frame representing VSI instance and
root/leaf attribute.
But now we're going too much into individual implementations so I repeat
my comment from the previous e-mail - It would be better if neutral NP
and ASIC-based solution vendors could analyze
both solutions and confirm impact on performance and scalability - and
BTW, we also need input regarding existing silicon that doesn't support
VLAN mapping.

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 1:04 PM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel,

I don't think we need to look up the VLAN and PW at the same time for
Dual-VLAN:
On the ingress PE, VLAN is firstly appended or translated for a incoming
Ethernet frame from AC, then MAC forwarded in VSI to one or multiple
logical ports each corresponding to a PW (the VLAN mapping may be
processed on a logical port), finally a PW label is appended and
transported over the corresponding PW.
On the egress PE, PW is popped and used to indicate a VSI (also
corresponding to a logical port, where the VLAN mapping may also be
processed), then MAC forwarded in VSI to one or multiple ports each
corresponding to an AC (where a frame with a leaf VLAN will be dropped
upon a leaf AC, actually, it is also a simple VLAN translation in IEEE,
that is, from leaf VLAN to 0xFFF, and all frames with this VLAN will be
dropped).

Therefore, double lookup of VLAN and PW seems unnecessary or even
impossible for this service IMHO. 

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:49 PM
To: Jiangyuanlong; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 9:43 AM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel, 

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 2:16 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander
Vainshtein
Cc: [email-masked]

Hi,

DC

-----Original Message-----

Sam,

a
seems
if
PW
Leaf-ACs
some
scenario,
and
understand
for
and
will
but
do
leaf
PE-
implicit

---

From: David Allan I <[email-masked]>
Date: Wed, 16 May 2012 12:20:36 -0400

Hi Sam:

Thanks for explaining your reasoning, this is useful.

Based on your comments I assume you believe that the scope of the S-tag is only the PW section, so it is imposed by the ingress PE and removed by the egress PE?

And you would prefer recreating an S-tag if an egress PE had a subtending PBN and stripping it if it in is an ingress from a PBN?

So this has little to do with ETREE itself, but tag interworking with a PBN or not?

Thanks
Dave

-----Original Message-----
From: Sam Cao [mailto:[email-masked]]
Sent: Tuesday, May 15, 2012 7:09 PM
To: 'Lucy yong'; David Allan I; 'Balus, Florin Stelian (Florin)'; 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Lucy/David/Florin,

I can not give the accurate data to support my conclusion, and just conclude that if we implement it in NP module. Except for common operations of 2 approaches, Tunnel Label push/pop-out, MAC-based forwarding, and etc., Dual-VLAN needs one more VLAN push/pop-out operation while forwarding every frame. So compared with Multi-PW, it needs more resource and time for NP module if there are VSIs or PWs up limit to the capacity on one PE, and standing on software architect's side, the performance will be decreased by at least 20%, I guess. I implemented one prototype which has similar solution as current Multi-PW, and the performance will be decreased by 5%, compared with traditional VPLS. Daniel has experience on 2-PW deployment, maybe he can give accurate data on Multi-PW.

Florin, do you mean that you have implemented E-Tree in MPLS network? If chipset can support this and we don't care NP or other solutions, yes, we can ignore any side effect on forwarding performance. Yes, it can support E-tree in IP (Ethernet) network, but I read some CHIP datasheets, after strip PW label out, chip can not handle 2 VLAN IDs at same time. Could you please give me some hints, say, which chip you used?

Maybe if we raised only one issue in one mail, we can get more and insight comments :). I will raise another after we agree with this in the main :).

Thanks,

Sam

-----Original Message-----
From: Lucy yong [mailto:[email-masked]]
Sent: Wednesday, May 16, 2012 4:15 AM
To: David Allan I; Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

+1

Lucy

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of David Allan I
Sent: Tuesday, May 15, 2012 2:55 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Florin:

Cheers
Dave

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Balus, Florin Stelian (Florin)
Sent: Tuesday, May 15, 2012 12:53 PM
To: Sam Cao; 'Jiangyuanlong'; 'Daniel Cohn'; 'Alexander Vainshtein'
Cc: [email-masked]
Subject: RE: Discussion on forwarding performance

Sam,

> Obviously the forwarding performance of Dual-VLAN will be much lower
> than
what of Multi-PW.

---

From: "Rogers, Josh" <[email-masked]>
Date: Wed, 16 May 2012 15:42:07 -0400

Yuanlong, I agree with your statement/assessment of where lookups occur to
decide how to forward (egress PE), howeverŠ  If optimization is done to
prevent the frame from being forwarded to PE's that have no AC's of the
appropriate type, then there has to some sort of mapping between the
ingress AC and the appropriate PW.  Earlier I assumed that this mapping
would be done by looking at the S-VLAN that would be applied on the
ingress PE physical interface.  In the case of optimization being used,
you'd see lookup of S-VLAN on both ingress and egress PE's, right?  If
not, how is the mapping between ingress AC and appropriate PW's done?

>> the dual-PW approach to E-Tree.

This E-mail and any of its attachments may contain Time Warner Cable proprietary information, which is privileged, confidential, or subject to copyright belonging to Time Warner Cable. This E-mail is intended solely for the use of the individual or entity to which it is addressed. If you are not the intended recipient of this E-mail, you are hereby notified that any dissemination, distribution, copying, or action taken in relation to the contents of and attachments to this E-mail is strictly prohibited and may be unlawful. If you have received this E-mail in error, please notify the sender immediately and permanently delete the original and any copy of this E-mail and any printout.

---

From: "Balus, Florin Stelian (Florin)" <[email-masked]>
Date: Wed, 16 May 2012 14:52:49 -0500

As soon as the packet is received on the ingress PE the ingress card (e.g. service manager) will know on what kind of entry point it arrived: i.e. whether it is a leaf or a root. Then right there it could make a decision whether it goes out on a PW or not. The SVLAN indication is really for the next PE in the chain.

> From: Rogers, Josh [mailto:[email-masked]]
> Sent: Wednesday, May 16, 2012 12:42 PM
> To: Jiangyuanlong; Daniel Cohn; Balus, Florin Stelian (Florin); Sam
> Cao; Alexander Vainshtein
> Cc: [email-masked]
> Subject: Re: Discussion on forwarding performance - 2VLAN
>
> Yuanlong, I agree with your statement/assessment of where lookups occur
> to decide how to forward (egress PE), howeverŠ  If optimization is done
> to prevent the frame from being forwarded to PE's that have no AC's of
> the appropriate type, then there has to some sort of mapping between
> the ingress AC and the appropriate PW.  Earlier I assumed that this
> mapping would be done by looking at the S-VLAN that would be applied on
> the ingress PE physical interface.  In the case of optimization being
> used, you'd see lookup of S-VLAN on both ingress and egress PE's,
> right?  If not, how is the mapping between ingress AC and appropriate
> PW's done?
>
>
>
> >On the ingress PE, VLAN is firstly appended or translated for a
> >incoming Ethernet frame from AC, then MAC forwarded in VSI to one or
> >multiple logical ports each corresponding to a PW (the VLAN mapping
> may
> >be processed on a logical port), finally a PW label is appended and
> >lookups are required (as in the dual-VLAN example, you need to lookup
> >PW label to identify E-Tree instance and then VLAN ID to identify
> >root/leaf origin), typically a single lookup is performed on ingress
> >with a composite search key (in this case, including PW label and VLAN
> ID).
> >> From: [email-masked] [mailto:[email-masked]] On
> >> Behalf Of Sam Cao
> >> frames. Obviously the forwarding performance of Dual-VLAN will be
> >> much lower than what of Multi-PW.
> >>
> >> Regards,
> >>
> >> Yuqun (Sam) Cao
> >> Leaf AC(one endpoint of this PW should be Root-only, otherwise this
> >> is invalid), one only can carry frames from Root AC, and the last
> can
> >> the PWs into 2 sets, one is Leaf set, and another is Root set, and
> >> the union of the sets Leaf and Root is the PW we called it as
> >> compatible
> >PW
> >> and Leaf-PWs, one between Root-ACs and Root-PWs. For traditional
> >> VPLS, there is only one mapping.
> >>
> >> [JY] It seems you may need a 3rd mapping: from both root & leaf AC
> to
> >a
> >> compatible PW.
> >> with another PE, Root-only, Leaf-only or Root-Leaf-Mixed. If 2 PEs
> >> are root-Leaf-Mixed or other cases, then 2 PWs will be established.
> >> As you know, this can be done on control plane.
> >>
> >> compatible PWs from PE3 which may carry both root and leaf traffic
> >> there
> >are
> >> Is this clear for you? Is this necessary to optimize PW setup in
> this
> >> case?
> >>
> >> As you know, initial design we will setup 2 PWs all the time (if do
> >> in this way, I think that you have no question),
> >>
> >> compatible or mixed PW. So the left items you list are not correct
> >> for multi_PW solution.
> >>
> >> what is your point: doesn't the mixed PW as you called also consist
> >> of one Leaf-only PW in one direction and one root-only PW in the
> >> other direction?
> >> traditional VSI assumes only one PW is required for each peer VSI,
> >> and its MAC leaning is based on bidirectional PW. But for 2PW, there
> >> are bidirectional root PW, bidirectional leaf PW, mixed PW, etc...,
> >> how to support these kinds of PWs in the same VSI is my top concern.
> >>
> >> when both PEs are mixed with root and leaf, so these PWs may be
> >> formed by combinations of the following unidirectional PW cases
> >> (extracted
> >and
> >> like root/spoke "core PW". So no changes to forwarding plane once
> >> this is understood.
> >>
> >> DC
> >>
> >> traffic over a leaf PW. It seems against the definition of root PW
> >> and leaf PW in the multi-PW draft. Don't this make the forwarding
> >> plane of PE-rs more complex?
> >>
> >> - twice (to both root-PW and Leaf-PW) to another MTU-s? And, BTW,
> how
> >> is the PW selected in this case?
> >>
> >> be probably used for the same purpose, but they would probably
> >> subject to similar HW-based limitations.
> >>
> This E-mail and any of its attachments may contain Time Warner Cable
> proprietary information, which is privileged, confidential, or subject
> to copyright belonging to Time Warner Cable. This E-mail is intended
> solely for the use of the individual or entity to which it is
> addressed. If you are not the intended recipient of this E-mail, you
> are hereby notified that any dissemination, distribution, copying, or
> action taken in relation to the contents of and attachments to this E-
> mail is strictly prohibited and may be unlawful. If you have received
> this E-mail in error, please notify the sender immediately and
> permanently delete the original and any copy of this E-mail and any
> printout.

---

From: "Rogers, Josh" <[email-masked]>
Date: Wed, 16 May 2012 16:09:17 -0400

Florin, thanks for the explanation.

Today, bridge (on a PE) expects to/from all endpoints in the domain.  Will
any particular effort in implementation have to be made to tie together
appropriate AC's with appropriate PW's?

This question should apply to both the 2VLAN and MultiPW methods, as both
seem to rely on these source-dependant (as opposed to the destination
based forwarding rules based on DST MAC only)

On 5/16/12 2:52 PM, "Balus, Florin Stelian (Florin)"
<[email-masked]> wrote:

>As soon as the packet is received on the ingress PE the ingress card
>(e.g. service manager) will know on what kind of entry point it arrived:
>i.e. whether it is a leaf or a root. Then right there it could make a
>decision whether it goes out on a PW or not. The SVLAN indication is
>really for the next PE in the chain.
>
>> >> Behalf Of Alexander Vainshtein

---

From: "Balus, Florin Stelian (Florin)" <[email-masked]>
Date: Wed, 16 May 2012 17:56:42 -0500

In my opinion both options are at the end of the day implementable. The VLAN one addresses more use cases/is consistent across native Ethernet and MPLS domains. The amount of effort is implementation dependent.

> Sent: Wednesday, May 16, 2012 1:09 PM
> To: Balus, Florin Stelian (Florin); Jiangyuanlong; Daniel Cohn; Sam
> Today, bridge (on a PE) expects to/from all endpoints in the domain.
> Will any particular effort in implementation have to be made to tie
> together appropriate AC's with appropriate PW's?
>
> This question should apply to both the 2VLAN and MultiPW methods, as
> both seem to rely on these source-dependant (as opposed to the
> destination based forwarding rules based on DST MAC only)
>
>
>
> >> Yuanlong, I agree with your statement/assessment of where lookups
> >> occur to decide how to forward (egress PE), howeverŠ  If
> optimization
> >> is done to prevent the frame from being forwarded to PE's that have
> >> no AC's of the appropriate type, then there has to some sort of
> >> mapping between the ingress AC and the appropriate PW.  Earlier I
> >> assumed that this mapping would be done by looking at the S-VLAN
> that
> >> would be applied on the ingress PE physical interface.  In the case
> >> of optimization being used, you'd see lookup of S-VLAN on both
> >> ingress and egress PE's, right?  If not, how is the mapping between
> >> ingress AC and appropriate PW's done?
> >>
> >>
> >>
> >> >corresponding to an AC (where a frame with a leaf VLAN will be
> >> >dropped upon a leaf AC, actually, it is also a simple VLAN
> >> >translation in
> >> IEEE,
> >> >that is, from leaf VLAN to 0xFFF, and all frames with this VLAN
> will
> >> be
> >> >dropped).
> >> >
> >> >From conversations with chip vendors, I understood that when
> >> >multiple lookups are required (as in the dual-VLAN example, you
> need
> >> >to lookup PW label to identify E-Tree instance and then VLAN ID to
> >> >identify root/leaf origin), typically a single lookup is performed
> >> >on ingress with a composite search key (in this case, including PW
> >> >label and VLAN
> >> ID).
> >> >But perhaps we are getting too much into implementation here. It
> >> >would be better if neutral NP and ASIC-based solution vendors could
> >> >analyze both solutions and confirm impact on performance and
> >> >scalability - and BTW, we also need input regarding existing
> silicon
> >> >that doesn't
> >> support
> >> >VLAN mapping.
> >> >
> >> >DC
> >> >
> >> >I agree that for a chip-based solution there should be no
> difference
> >> in
> >> >performance for the additional lookup. However from conversations
> >> >with chip vendors, I understood there might be an impact on
> >> >scalability because the double lookup would require a longer search
> >> >key (assuming VLAN and VCID lookups are performed simultaneously on
> >> >ingress), thus taking up more TCAM resources per E-Tree instance.
> >> >This would depend
> >> on
> >> >Sorry I could not keep up with some of the threads on this subject
> >> >but the above statement caught my eyes. We have been doing all kind
> >> >of egress operations on VLANs in the egress PE for the last 8 years
> >> >and I am not aware of any "much lower" forwarding performance. As
> >> >far as I know the chipsets used in the PEs can do this processing
> no problem.
> >> Do
> >> >> we use Dual-VLAN, after strip PW label out, data plane should
> >> >> strip VLAN-ID out and then does same forwarding work as Multi-PW
> >> >> does. The most important is, do one more operation while
> >> >> forwarding E-Tree frames. Obviously the forwarding performance of
> >> >> Dual-VLAN will be much lower than what of Multi-PW.
> >> >>
> >> >> Regards,
> >> >>
> >> >> Yuqun (Sam) Cao
> >> >> Thank you very much for your comments. I draw the topology you
> >> >> gave, and 7 PWs will be established if we follow 01.
> >> >>
> >> >> Leaf AC(one endpoint of this PW should be Root-only, otherwise
> >> >> this is invalid), one only can carry frames from Root AC, and the
> >> >> last
> >> can
> >> >> PWs (bidirectional PW, but just carry unidirectional frames),
> >> >> Root-
> >> PW
> >> >> this PW as compatible PW or something else. Frames originated
> from
> >> >Root
> >> >> or leaf ACs will be carried via this PW. Its forwarding behavior
> >> >> is fully same as what traditional VPLS did, MAC learning on AC or
> >> >> PW in one E-Tree. Or say, if one PE has Root-only ACs, it will
> >> >> setup one
> >> PW
> >> >> 4 different types of PW receiving behaviours. Not sure how you
> >> >> will accommodate for these PWs in both the data plane and control
> plane.
> >> >>
> >> >> Regards,
> >> >> Yuanlong
> >> >>
> >> >> We have discussed this in another thread. In fact, Daniel or I
> >> >> have given the answers to the questions you raised here for
> >> >> several time
> >> >:).
> >> >> As you know, initial design we will setup 2 PWs all the time (if
> >> >> do in this way, I think that you have no question),
> >> >>
> >> >> leaf PW" is not correct: On Leaf-only side, yes, one Leaf-only PW
> >> >> is created between Local Leaf type with remote Root type; on
> >> >> root-only side, one root-only PW is created. Maybe it is better
> to
> >> >> call this
> >> as
> >> >> what is your point: doesn't the mixed PW as you called also
> >> >> consist of one Leaf-only PW in one direction and one root-only PW
> >> >> in the other direction?
> >> >> "Root-only VSI <-> any VSI: only root PW required", don't you
> >> >> think that only one root PW is required following this guideline?
> >> >> and its MAC leaning is based on bidirectional PW. But for 2PW,
> >> >> there are bidirectional root PW, bidirectional leaf PW, mixed PW,
> >> >> etc..., how to support these kinds of PWs in the same VSI is my
> top concern.
> >> >>
> >> >> example, if we configure one Leaf AC on root-only PE (then it
> will
> >> be
> >> >> root-leaf-mixed PE), we will teardown the compatible PW and
> >> >> Fine, now it seems more in line with what we had proposed in
> 2VLAN:
> >> a
> >> >> Root-only -> any VSI = one root PW Leaf-only -> root-only = one
> >> >> leaf PW Leaf-only -> mixed = one leaf PW Mixed -> root-only = one
> >> >> (root+leaf) PW Mixed -> leaf-only = one
> >> >> (root+leaf) PW
> >> >>
> >> >> Like I wrote below, root/leaf spoke PW behave like root/leaf AC,
> >> >> not like root/spoke "core PW". So no changes to forwarding plane
> >> >> once this is understood.
> >> >>
> >> >> DC
> >> >>
> >> >> As I see it, for the PE-r spoke (figure 4 in RFC 4762) we
> >> >> establish
> >> a
> >> >> single PW per AC - root PW for root AC and leaf PW for leaf AC.
> >> >> With local configuration at the PE-rs as part of the spoke PW
> >> provisioning.
> >> >> root/leaf ACs. So when leaf-originated BUM traffic arrives from
> >> >> the core (over a leaf PW), it will be forwarded over all root
> >> >> spoke PWs
> >> >but
> >> >> The forwarding plane is exactly the same as described in the
> >> >> multi-
> >> PW
> >> >> If filtered on the PE-r, then lots of bandwidth will be wasted
> >> >> (for example, if the PE-r is attached with 9 leafs, then the BUM
> >> >> traffic from one of its leafs will be multiplied by 8 times, and
> >> >> be
> >> forwarded
> >> >> information is propagated across the VPLS. So in the H-VPLS
> >> >> example, the PE-r will never forward a frame received over a root
> >> >> PW on any
> >> >leaf
> >> >> If this is the case, what kind of forwarding logic should be used
> >> >> to prevent sending a BUM frame received from a root-PW to a given
> >> >> MTU-
> >> S:
> >> >> which could be possibly used for this purpose. However, since
> >> >> these groups have to be represented explicitly in the data plane,
> >> >> their potential number is limited by the forwarding HW. Other
> >> >> methods
> >> could
> >> >> limit, say, on a number of MTU-s that can be connected to the
> same
> >> >PE-r
> >> >> Based on this I suspect that the H-VPLS issue as a critical
> >> >> drawback
> >> >of
> >> >> From: [email-masked] [[email-masked]] on behalf
> of
> >> >> Sam Cao [[email-masked]]
> >> >> [Lizhong] agree with the above analysis. And we did not say it is
> >> >> a technical problem, but it is an operational problem again.
> >> >> [Sam] I agree. Dual-VLAN does not make sense. I also discussed
> >> >> this with Giles and Yuanlong in another mail, and we reached
> >> >> agreement on
> >> >> this:
> >> proprietary information, which is privileged, confidential, or
> >> subject to copyright belonging to Time Warner Cable. This E-mail is
> >> intended solely for the use of the individual or entity to which it
> >> is addressed. If you are not the intended recipient of this E-mail,
> >> you are hereby notified that any dissemination, distribution,
> >> copying, or action taken in relation to the contents of and
> >> attachments to this E- mail is strictly prohibited and may be
> >> unlawful. If you have received this E-mail in error, please notify
> >> the sender immediately and permanently delete the original and any
> >> copy of this E-mail and any printout.
>
>

---

From: Jiangyuanlong <[email-masked]>
Date: Thu, 17 May 2012 01:59:18 +0000

[JY] For an E-Tree, the outmost VLAN in a PW can only have two possible values: either root or leaf VLAN. Thus we don't need TCAM to find the corresponding VLAN. Even if TCAM is used, only two TCAM items are needed at most, no matter what is the search key length. So I can't see the scalability issue in this regards.

[JY] In principle, I agree with you. However, a fair analysis is possible only when the data plane of both approaches are fully understood, but I am not sure this is the case for the Multi-PW approach, since both the forwarding plane and OAM, two most important constructs of its data plane, is still in the dark, please see http://www.ietf.org/mail-archive/web/l2vpn/current/msg03636.html and http://www.ietf.org/mail-archive/web/l2vpn/current/msg03554.html for details. 
For Dual-VLAN, the forwarding plane is very detailed in draft-jiang-l2vpn-vpls-pe-etree, and the OAM as described in RFC 6136 will apply with no change.

Thanks,
Yuanlong

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 1:04 PM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel,

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 4:49 PM
To: Jiangyuanlong; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

DC

-----Original Message-----
From: Jiangyuanlong [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 9:43 AM
To: Daniel Cohn; Balus, Florin Stelian (Florin); Sam Cao; Alexander
Vainshtein
Cc: [email-masked]

Daniel, 

Regards,
Yuanlong

-----Original Message-----
From: Daniel Cohn [mailto:[email-masked]] 
Sent: Wednesday, May 16, 2012 2:16 PM
To: Balus, Florin Stelian (Florin); Sam Cao; Jiangyuanlong; Alexander
Vainshtein
Cc: [email-masked]

Hi,

DC

-----Original Message-----

Sam,

than what of Multi-PW.

a
seems
if
PW
Leaf-ACs
some
scenario,
and
understand
for
and
will
but
do
leaf
PE-
implicit

---

From: Jiangyuanlong <[email-masked]>
Date: Thu, 17 May 2012 02:41:19 +0000

Josh,

ingress AC and the appropriate PW. 

[JY] I assume the optimization you mean is filtering the leaf traffic on the ingress PE and not sending it to the leaf-only PE, right?
I think there is no direct mapping from an ingress AC to a PW (except for spoke PW in H-VPLS), as you know, there is only one PW between PEs in Dual-VLAN solution.

 Earlier I assumed that this mapping

[JY] In the case of optimization, the ingress PE may further filter the leaf traffic on the logical ports corresponding to a PW which is connected to a leaf-only remote PE (just as I said before, the VLAN mapping may be processed on a logical port), this was described in section 5.3.3 of draft-jiang-l2vpn-vpls-pe-etree-05. But in a PW for E-Tree, as only 2 VLAN values are possible, so we don't even need a table to implement it.

Regards,
Yuanlong

---

From: Jiangyuanlong <[email-masked]>
Date: Thu, 17 May 2012 03:45:48 +0000

Hi Josh,

-----Original Message-----
From: Rogers, Josh [mailto:[email-masked]] 
Sent: Thursday, May 17, 2012 4:09 AM
To: Balus, Florin Stelian (Florin); Jiangyuanlong; Daniel Cohn; Sam Cao; Alexander Vainshtein
Cc: [email-masked]
Subject: Re: Discussion on forwarding performance - 2VLAN

[JY] Maybe I am naïve, But I think in general it is not possible to tie an AC with one or more PWs directly except for some very special topology, once they are tied together, the MP2MP characteristic of bridge or VPLS is lost. ACL may be used to help source-dependant forwarding rules but with some more cost.

Regards,
Yuanlong